<template>
  <div class="content">
    <h3 class="h2">
      <i
        class="fa fa-graduation-cap"
        style="padding-right: 5px; font-size: 35px"
      ></i
      ><strong>Manajemen Prodi</strong>
    </h3>
    <h4>
      Tabel Fakultas - Tabel Prodi - Tabel Profil Prodi - Tabel Kegiatan Prodi
    </h4>

    <modal v-if="classicModal" @close="classicModalHide">
      <template slot="header">
        <h4 class="modal-title h3" style="margin-top: 100px">
          <strong>Fakultas</strong>
        </h4>
        <md-button
          class="md-simple md-just-icon md-round modal-default-button"
          @click="classicModalHide"
        >
          <md-icon>clear</md-icon>
        </md-button>
      </template>

      <template slot="body">
        <div class="conteiner">
          <md-field class="md-form-group" style="margin-bottom: 20px">
            <md-icon></md-icon>
            <label>Masukkan Nama Fakultas...</label>
            <md-input
              v-model="fakultasData.nama_fakultas"
              type="text"
            ></md-input>
          </md-field>
          <md-field class="md-form-group">
            <md-icon></md-icon>
            <label>Masukkan Singkatan Fakultas...</label>
            <md-input
              v-model="fakultasData.singkatan_fakultas"
              type="text"
            ></md-input>
          </md-field>
        </div>
      </template>

      <template slot="footer">
        <div style="margin-top: 50px; margin-bottom: 110px">
          <md-button class="md-success" @click="onSubmit">Submit</md-button>
          <md-button class="md-danger md-simple" @click="classicModalHide"
            >Close</md-button
          >
        </div>
      </template>
    </modal>

    <md-table
      :value="fakultasList"
      md-sort="name"
      md-sort-order="asc"
      md-card
      md-fixed-header
    >
      <md-table-toolbar>
        <div class="md-toolbar-section-start">
          <h1 class="md-title"><strong>Tabel Fakultas</strong></h1>
        </div>
        <div>
          <div class="md-layout-item">
            <md-button class="md-success md-block" @click="classicModal = true">
              + Buat Fakultas
            </md-button>
          </div>
        </div>
        <!-- <md-field md-clearable class="md-toolbar-section-end">
                  <md-input
                    placeholder="Search by name..."
                    v-model="search"
                    @input="searchOnTable"
                  />
                </md-field> -->
      </md-table-toolbar>

      <!-- <md-table-empty-state
                style="padding-top: -20px;margin-top:0px;top: -400px"
                md-label="No users found"
                :md-description="
                  `No user found for this '${search}' query. Try a different search term or create a new user.`
                "
              >
              </md-table-empty-state> -->

      <md-table-row
        slot="md-table-row"
        v-for="(fakultas, key) in fakultasList"
        :key="key"
        slot-scope="{ item }"
      >
        <md-table-cell md-label="ID" md-sort-by="id" style="padding-left: 15px">
          {{ item.id }}
        </md-table-cell>
        <md-table-cell md-label="Nama Fakultas" md-sort-by="nama_fakultas">
          {{ item.nama_fakultas }}
        </md-table-cell>
        <md-table-cell md-label="Singkatan">
          {{ item.singkatan_fakultas }}
        </md-table-cell>
        <md-table-cell>
          <router-link
            :to="{
              name: 'fakultas-update',
              params: { id: item.id }
            }"
          >
            <i
              class="fa fa-edit"
              aria-hidden="true"
              style="color: green; font-size: 18px; padding-right: 20px"
              ><md-tooltip md-direction="bottom">Update Fakultas</md-tooltip></i
            >
          </router-link>
        </md-table-cell>
      </md-table-row>
    </md-table>

    <md-table
      :value="prodiList"
      md-sort="name"
      md-sort-order="asc"
      md-card
      md-fixed-header
    >
      <md-table-toolbar>
        <div class="md-toolbar-section-start">
          <h1 class="md-title"><strong>Tabel Prodi</strong></h1>
        </div>
        <div>
          <a
            href="#/dashboard/prodi-create"
            class="md-list-item-router md-list-item-container md-button-clean"
          >
            <md-button
              class="md-success"
              style="padding: 10px 0px 0px 0px; height: 50px"
            >
              <p class="md-list-item-text" style="color: white;font-size: 12px">
                + Buat Prodi
              </p>
            </md-button>
          </a>
        </div>
        <!-- <md-field md-clearable class="md-toolbar-section-end">
                  <md-input
                    placeholder="Search by name..."
                    v-model="search"
                    @input="searchOnTable"
                  />
                </md-field> -->
      </md-table-toolbar>

      <!-- <md-table-empty-state
                style="padding-top: -20px;margin-top:0px;top: -400px"
                md-label="No users found"
                :md-description="
                  `No user found for this '${search}' query. Try a different search term or create a new user.`
                "
              >
              </md-table-empty-state> -->

      <md-table-row
        slot="md-table-row"
        v-for="(prodi, key) in prodiList"
        :key="key"
        slot-scope="{ item }"
      >
        <md-table-cell
          md-label="ID"
          md-sort-by="id"
          style="padding-left: 20px; padding-right: 30px"
        >
          {{ item.id }}
        </md-table-cell>
        <md-table-cell md-label="Nama Prodi" md-sort-by="nama_prodi">
          {{ item.nama_prodi }}
        </md-table-cell>
        <md-table-cell md-label="Singkatan" style="padding-right: 30px">
          {{ item.singkatan_prodi }}
        </md-table-cell>
        <md-table-cell md-label="Fakultas" md-sort-by="fakultas.nama_fakultas">
          {{ item.fakultas.nama_fakultas }}
        </md-table-cell>
        <md-table-cell
          md-label="Logo"
          style="width: 120px; padding-right: 50px"
        >
          <img :src="item.logo" class="rounded" alt="logo" />
        </md-table-cell>
        <md-table-cell>
          <router-link
            :to="{
              name: 'prodi-update',
              params: { id: item.id }
            }"
          >
            <i
              class="fa fa-edit"
              aria-hidden="true"
              style="color: green; font-size: 18px; padding-right: 20px"
              ><md-tooltip md-direction="bottom">Update Prodi</md-tooltip></i
            >
          </router-link>
        </md-table-cell>
      </md-table-row>
    </md-table>

    <md-table
      :value="profilProdiList"
      md-sort="name"
      md-sort-order="asc"
      md-card
      md-fixed-header
    >
      <md-table-toolbar>
        <div class="md-toolbar-section-start">
          <h1 class="md-title"><strong>Tabel Profil Prodi</strong></h1>
        </div>
        <div>
          <a
            href="#/dashboard/profil-prodi-create"
            class="md-list-item-router md-list-item-container md-button-clean"
          >
            <md-button
              class="md-success"
              style="padding: 10px 0px 0px 0px; height: 50px"
            >
              <p class="md-list-item-text" style="color: white;font-size: 12px">
                + Buat Profil Prodi
              </p>
            </md-button>
          </a>
        </div>
      </md-table-toolbar>

      <md-table-row
        slot="md-table-row"
        v-for="(profilProdi, key) in profilProdiList"
        :key="key"
        slot-scope="{ item }"
      >
        <!-- <md-table-cell md-label="ID" md-sort-by="id" style="padding-left: 20px; padding-right: 30px">
          {{ item.id }}
        </md-table-cell> -->
        <md-table-cell
          md-label="  Prodi"
          md-sort-by="prodi.nama_prodi"
          style="width: 150px;padding-left: 10px"
        >
          {{ item.prodi.nama_prodi }}
        </md-table-cell>
        <md-table-cell
          md-label="Nama Kaprodi"
          md-sort-by="nama_kaprodi"
          style="width: 300px"
        >
          {{ item.nama_kaprodi }}
        </md-table-cell>
        <md-table-cell
          md-label="Kategori Thesis"
          md-sort-by="kategori_thesis"
          style="padding-right: 50px"
        >
          {{ item.kategori_thesis }}
        </md-table-cell>
        <md-table-cell md-label="Foto" style="width: 120px;">
          <img
            :src="item.image_kaprodi"
            class="rounded"
            alt="image_kaprodi"
            style="width: 50px"
          />
        </md-table-cell>
        <md-table-cell
          md-label="Tahun"
          md-sort-by="tahun"
          style="width: 100px;"
        >
          {{ item.tahun.tahun }}
        </md-table-cell>
        <md-table-cell>
          <router-link
            :to="{
              name: 'profil-prodi-update',
              params: { id: item.id }
            }"
          >
            <i
              class="fa fa-edit"
              aria-hidden="true"
              style="color: green; font-size: 18px; padding-right: 20px"
              ><md-tooltip md-direction="bottom"
                >Update Profil Prodi</md-tooltip
              ></i
            >
          </router-link>
        </md-table-cell>
      </md-table-row>
    </md-table>

    <md-table
      :value="kegiatanProdiList"
      md-sort="name"
      md-sort-order="asc"
      md-card
      md-fixed-header
    >
      <md-table-toolbar>
        <div class="md-toolbar-section-start">
          <h1 class="md-title"><strong>Tabel Kegiatan Prodi</strong></h1>
        </div>
        <div>
          <a
            href="#/dashboard/kegiatan-prodi-create"
            class="md-list-item-router md-list-item-container md-button-clean"
          >
            <md-button
              class="md-success"
              style="padding: 10px 0px 0px 0px; height: 50px"
            >
              <p class="md-list-item-text" style="color: white;font-size: 12px">
                + Buat Kegiatan Prodi
              </p>
            </md-button>
          </a>
        </div>
      </md-table-toolbar>

      <md-table-row
        slot="md-table-row"
        v-for="(kegiatanProdi, key) in kegiatanProdiList"
        :key="key"
        slot-scope="{ item }"
      >
        <md-table-cell
          md-label="ID"
          md-sort-by="id"
          style="padding-left: 20px; padding-right: 30px"
        >
          {{ item.id }}
        </md-table-cell>
        <md-table-cell
          md-label="Nama Prodi"
          md-sort-by="prodi.nama_prodi"
          style="width: 150px;padding-right: 50px"
        >
          {{ item.prodi.nama_prodi }}
        </md-table-cell>
        <md-table-cell md-label="Foto" style="width: 100px;">
          <img
            :src="item.image"
            class="rounded"
            alt="image"
            style="width: 80px"
          />
        </md-table-cell>
        <md-table-cell
          md-label="Deskripsi"
          style="width: 550px;padding-right: 20px"
        >
          {{ item.subtitle }}
        </md-table-cell>
        <md-table-cell
          md-label="Tahun"
          md-sort-by="tahun"
          style="width: 100px;"
        >
          {{ item.tahun.tahun }}
        </md-table-cell>
        <md-table-cell>
          <router-link
            :to="{
              name: 'kegiatan-prodi-update',
              params: { id: item.id }
            }"
          >
            <i
              class="fa fa-edit"
              aria-hidden="true"
              style="color: green; font-size: 18px; padding-right: 20px"
              ><md-tooltip md-direction="bottom"
                >Update Kegiatan Prodi</md-tooltip
              ></i
            >
          </router-link>
        </md-table-cell>
      </md-table-row>
    </md-table>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { Modal } from "@/components";
import moment from "moment";

const toLower = text => {
  return text.toString().toLowerCase();
};

const searchByName = (items, term) => {
  if (term) {
    return items.filter(item =>
      toLower(item.prodi.nama_prodi).includes(toLower(term))
    );
  }

  return items;
};

export default {
  components: {
    Modal
  },
  bodyClass: "login-page",
  //   data() {},
  data: () => ({
    classicModal: false,
    search: null,
    searched: []
    // currentSort: "name",
    // currentSortOrder: "asc"
  }),
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("fakultas", ["fakultasList", "fakultasData"]),
    ...mapState("prodi", ["prodiList"]),
    ...mapState("profilProdi", ["profilProdiList"]),
    ...mapState("kegiatanProdi", ["kegiatanProdiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("fakultas", ["getFakultasList", "createFakultas"]),
    ...mapActions("prodi", ["getProdiList"]),
    ...mapActions("profilProdi", ["getProfilProdiList"]),
    ...mapActions("kegiatanProdi", ["getKegiatanProdiList"]),
    async onFetchData() {
      await this.getFakultasList();
      await this.getProdiList();
      await this.getProfilProdiList();
      await this.getKegiatanProdiList();
    },
    async onSubmit() {
      await this.createFakultas({ payload: this.fakultasData });
      this.fakultasData = {};
      this.$router.push({ name: "dashboard" });
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    },
    searchOnTable() {
      this.searched = searchByName(this.kegiatanprodiList, this.search);
    },
    classicModalHide() {
      this.classicModal = false;
    }
    // customSort(value) {
    //   return value.sort((a, b) => {
    //     const sortBy = this.currentSort;

    //     if (this.currentSortOrder === "desc") {
    //       return a[sortBy].localeCompare(b[sortBy]);
    //     }

    //     return b[sortBy].localeCompare(a[sortBy]);
    //   });
    // }
  },
  async mounted() {
    this.onResponsiveInverted();
    await this.onFetchData();
    window.addEventListener("resize", this.onResponsiveInverted);
  },
  created() {
    this.searched = this.wisudawanList;
  }
};
</script>

<style lang="scss" scoped>
.md-progress-bar {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}
</style>

<style lang="css"></style>
